/* ==== item.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdlib.h>
#include "C-foogrid.h"
#include "porrog_defs.h"
/* #include "maparray.h" Don't think we use this one any more.*/
#include "structures.h" /*Hers's where that stuff is now*/
#include "item.h"

void add_item(foogrid *map,int y, int x,itemtype_t *otype)
{
   item_t *newitem;
   long offset=foogrid_idx(map,y,x);
   maploc_t *mapstart=map->Data; /*Got access to coords*/

   newitem=(item_t *)malloc(sizeof(item_t));
   newitem->Itemtype=otype;
   /* Got a new object */
   newitem->Next=(mapstart+offset)->Itemlist;
   (mapstart+offset)->Itemlist=newitem;
   /*Its on top of the stack there. We don't return anything */
}
/* Places a new instance of otype at the position given */

void new_itemtype(itemtype_t *space,char symbol,char *name)
{
    space->Symbol=symbol;
    space->Name=name; /*You'd better not free name later...*/
    /* Hmm, is that all?*/
}

/* Removes top item from a heap on the floor, returns it (with
   that item individualised)*/
item_t *skim_item(foogrid *map,int x,int y)
{
   long offset=foogrid_idx(map,y,x);
   maploc_t *mapstart=map->Data;
   item_t *item;
   item=(mapstart+offset)->Itemlist;
   if (NULL==item) return(NULL);
   (mapstart+offset)->Itemlist=item->Next;
   item->Next=NULL;
   return(item);
}
/* Puts an item on top of heap on floor. Assumes item is alone.*/
void place_item(foogrid *map,int x,int y,item_t *item)
{
   long offset=foogrid_idx(map,y,x);
   maploc_t *mapstart=map->Data;
   if (NULL==item) return; /* To be safe*/
   item->Next=(mapstart+offset)->Itemlist;
   (mapstart+offset)->Itemlist=item;
}
