/* ==== main.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include "porrog_defs.h"
#include <ncurses.h>
#include <unistd.h>
#include <stddef.h>
#include "C-foogrid.h" /* Used for foogrid*/
#include "maparray.h"
#include "ui.h"
#include "crash.h"
#include "dXrng.h"
#include "memutils.h"
#include "structures.h"
#include "monster.h"
#include "version.h"

mobtype_t *pm_type; /* A base type for player monster.*/
monster_t *playermob; /* A player data pointer */
char strbuf[160];/* For sprintf*/

int main(int argc, char **argv)
{
    int x=(MAPWID/2)-25,y=(MAPHGT/2)-10,quit=0;
    char k;
    char *version_string=(char *)malloc(80*sizeof(char));
    version(version_string);printf("%s\n",version_string);
    /* Should really do that elsewhere, like in ui.c */
    initialise_dXrng();
    if (initscr()==NULL) crash(SCREEN_ERROR);
    notimeout(stdscr, 1);
    noecho();
    cbreak();
    make_map();
    pm_type=(mobtype_t *)malloc(sizeof(mobtype_t));
    playermob=(monster_t *)malloc(sizeof(monster_t));
    new_mobtype(pm_type,'@',"Player","This is you!");
    playermob=add_mob(map,(MAPHGT/2),(MAPWID/2),pm_type);
    while(quit==0)
    {
      draw_map(x,y); /* Somewhere in the middle */
      k=getch();
      switch (k){
         case 'h':
            /*
            x-=12; */
            move_mob(map,-1,0,playermob);
            if (playermob->Pos.X<(x+16)) {x=(playermob->Pos.X-26);}
            if(x<0) x=0;
            break;
         case 'j':
            /*
            y+=5; */
            move_mob(map,0,1,playermob);
            if (playermob->Pos.Y>(y+15)) {y=(playermob->Pos.Y-10);}
            if(y>(MAPHGT-23)) y=(MAPHGT-23);
            break;
         case 'k':
            /*
            y-=5;*/
            move_mob(map,0,-1,playermob);
            if (playermob->Pos.Y<(y+7)) {y=(playermob->Pos.Y-13);}
            if(y<0) y=0;
            break;
         case 'l':
            /*
            x+=12;*/
            move_mob(map,1,0,playermob);
            if (playermob->Pos.X>(x+32)) {x=(playermob->Pos.X-24);}
            if(x>(MAPWID-51)) x=(MAPWID-50);
            break;
         case 'q':
            quit=1;
            break;
         case 'r':
            sprintf(strbuf,"Room %d.  ",find_room(playermob->Pos.X,playermob->Pos.Y));
            move(4,1);addstr(strbuf);
            break;
         case 'v':
            version(strbuf);
            move(4,1);addstr(strbuf);
         case 'i':
            display_heap(playermob->Inventlist);
            break;
         case ';':
            display_heap(((maploc_t *)(map->Data)+foogrid_idx(map,playermob->Pos.Y,playermob->Pos.X))->Itemlist);
            break;
         case ',':
            get_item(playermob,skim_item(map,playermob->Pos.X,playermob->Pos.Y));
            display_heap(playermob->Inventlist);
            break;
         case 'd':
            place_item(map,playermob->Pos.X,playermob->Pos.Y,discard_item(playermob));
            display_heap(playermob->Inventlist);
            break;
         case 'm':
            make_map();
            break;
         default:
      }
    }
    addstr("Quitting.\n");
    endwin();
    printf("%ld unfreed allocations made.\n",check_allocs());
    exit(0);
}
