/* ==== monster.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdlib.h>
#include "C-foogrid.h"
#include "structures.h"
#include "monster.h"

monster_t *add_mob(foogrid *map,int y,int x,mobtype_t *mtype)
{
   monster_t *newmob;
   long offset=foogrid_idx(map,y,x);
   maploc_t *mapstart=map->Data;
   newmob=(monster_t *)malloc(sizeof(monster_t));
   newmob->Mobtype=mtype;
   newmob->Inventlist=NULL; /*Carrying nothing.*/
   newmob->Pos.X=x;newmob->Pos.Y=y; /*Monster knows where it is*/
   (mapstart+offset)->Mptr=newmob; /*Map knows where it is*/
   return(newmob);
}

void new_mobtype(mobtype_t *space, char sym, char *name,char *desc)
{
    space->Symbol=sym;
    space->Name=name;
    space->Desc=desc;
}

void move_mob(foogrid *map, int dx, int dy, monster_t *mob)
{
    maploc_t *mapstart=map->Data;
    int x,y;
    x=mob->Pos.X;y=mob->Pos.Y;
    (mapstart+foogrid_idx(map,y,x))->Mptr=NULL;
    x+=dx;y+=dy;
    mob->Pos.X=x;mob->Pos.Y=y;
    (mapstart+foogrid_idx(map,y,x))->Mptr=mob;
}

void get_item(monster_t *mob,item_t *item)
{
    /* Assumes item is individual: item->Next MUST be NULL*/
    if (item==NULL) return; /*Play it safe*/
    item->Next=mob->Inventlist;
    mob->Inventlist=item;
}
item_t *discard_item(monster_t *mob)
{
    /* Removes top item from monster's inventory. Returns it
      as an individual item.*/
    item_t *item=mob->Inventlist;
    if (item==NULL) return(NULL); /*Plausible*/
    mob->Inventlist=item->Next;
    item->Next=NULL;
    return(item);
}
